Subject: bug#18222: 24.3.92; fork handlers in gmalloc.c can lead to deadlock

From: Ken Brown <[email-masked]>
Date: Mon, 25 Aug 2014 08:17:49 -0400

On 8/24/2014 10:39 PM, Eli Zaretskii wrote:
> The problem is how to write the DUMPED and ALLOCATED_BEFORE_DUMPING
> macros.  For Cygwin, they use some intimate knowledge about Cygwin
> runtime internals; the question is, do other platforms have similar
> facilities and features.

The macros on Cygwin don't use any knowledge about Cygwin runtime 
internals.  They use knowledge about how gmalloc and unexec work on 
Cygwin.  Prior to dumping, gmalloc uses a version of sbrk defined in 
sheap.c, which allocates space in the static heap (also defined in 
sheap.c).  But the question still remains about what to do on other 
platforms.

Ken